<template>
  <div class="p-8 admin admin-dashboard">
    <div class="admin-dashboard__wrapper rounded-24 bg-bgdsec relative pb-20 overflow-hidden">
      <transition name="default-plug">
        <div v-show="loading" class="default-plug absolute inset-0 z-1">
          <div class="flex items-center justify-center w-full h-full"><LoadingSpinner /></div>
        </div>
      </transition>
      <div class="mt-8 w-full flex items-center gap-4 relative px-6">
        <div class="h-0.5 w-full absolute bottom-0 left-0 bg-brdddef rounded-100"></div>
        <div
          v-for="category in categories"
          :key="category.key"
          class="h-9 cursor-pointer relative hover:text-txtdprim px-1"
          :class="category.key === currentCategory.key ? 'text-txtdprim' : 'text-txtdsec'"
          @click="currentCategory = category"
        >
          <p class="text-center leading-5 font-medium">
            {{ category.title }}
          </p>
          <div
            v-show="category.key === currentCategory.key"
            style="height: 3px; transform: translateY(0.5px)"
            class="w-full absolute bottom-0 left-0 rounded-100 bg-blue"
          ></div>
        </div>
      </div>
      <keep-alive :max="3">
        <component :is="currentComponent" />
      </keep-alive>
    </div>
  </div>
</template>

<script>
import UserList from '@/components/views/admin/users/UserList.vue';
import CurrenciesList from '@/components/views/admin/currencies/CurrenciesList.vue';
import ProjectList from '@/components/views/admin/projects/ProjectList.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiPagination from '@/components/ui/UiPagination.vue';

export default {
  name: 'AdminDashboard',

  components: { UiPagination, LoadingSpinner, ProjectList, CurrenciesList, UserList },

  data() {
    return {
      currentCategory: {
        title: 'Projects',
        key: 'projects',
      },

      categories: [
        {
          title: 'Projects',
          key: 'projects',
        },
        {
          title: 'Super Users',
          key: 'super-users',
        },
        {
          title: 'Currencies',
          key: 'currencies',
        },
      ],
    };
  },

  computed: {
    loading() {
      return this.$store.state.auth.adminLoading;
    },

    currentComponent() {
      if (this.currentCategory.key === 'super-users') return UserList;
      if (this.currentCategory.key === 'currencies') return CurrenciesList;
      return 'ProjectList';
    },
  },
};
</script>

<style lang="scss">
.admin-dashboard {
  &__wrapper {
    min-height: calc(100vh - 64px);
  }
}
</style>
